#include <Servo.h>

int ledPin = 13;  //定义LED引脚13
int vol = 0;      //定义一个vol

char buf_1[] = {0xAA,0X55};    //帧头
char buf_2[] = {0x55,0XAA};    //帧尾

/*************************************************************
 基础知识梳理：
 void setup（）： 这个函数是最开始的时候运行一次，（初始化函数）。
 void loop （）：这个函数是执行函数，会不断循环工作，（死循环函数)。 

Serial.bengin() :这个函数对串口定义波特率
Serial.read() :    这个函数读串口并返回收到参数读取1byte的序列资料（读取串口的输入）
Serial.printnl():  在串口端打印输出数据（在串口打印输出）
*************************************************************/

void setup() 
{
  Serial.begin(9600);
  // 参数speed是指串口通信波特率，波特率是指每秒传输的比特数，除以8就可以得到每秒传输的字节数，一般用9600、19200、57600、115200。
  pinMode( ledPin, OUTPUT);

}
 
void loop()//进入死循环，一直在这里轮回
{ 
  while (Serial.available()>0)//当串口接收到数据
    {
       char vol = Serial.read();//将接收到的数据赋值给vol
       switch(vol)                               //判断串口收到了哪个数据
         {
           case 1 :Blink1();break;              //如果串口收到1   LED亮灭一次
                   
           case 2 :Blink2();break;              //如果串口收到2   LED亮灭二次
                   
           case 3 :Blink3();break;              //如果串口收到3   LED亮灭三次
                   
           case 4 :Serial.write(buf_1,2);Serial.write(4);Serial.write(11);
                   Serial.write(buf_2,2);Blink1();break;//收到4 发送AA 55 04 0B 55 AA
           
           case 5 :Serial.write(buf_1,2);Serial.write(5);Serial.write(22);
                   Serial.write(buf_2,2);Blink2();break;//收到5 发送AA 55 05 16 55 AA
                   
           case 6 :Serial.write(buf_1,2);Serial.write(6);Serial.write(33);
                   Serial.write(buf_2,2);Blink3();break;//收到6 发送AA 55 06 21 55 AA
                   
           case 7 :Serial.write(buf_1,2);Serial.write(7);Serial.write(33);
                   Serial.write(buf_2,2);Blink3();break;//收到7 发送AA 55 07 21 55 AA
                   
           case 8 :Serial.write(buf_1,2);Serial.write(8);Serial.write(33);
                   Serial.write(buf_2,2);Blink2();break;//收到8 发送AA 55 08 21 55 AA
                   
           case 9 :Serial.write(buf_1,2);Serial.write(9);Serial.write(33);
                   Serial.write(buf_2,2);Blink1();break;//收到9 发送AA 55 09 21 55 AA
                   
           case 10 :Serial.write(buf_1,2);Serial.write(10);Serial.write(33);
                   Serial.write(buf_2,2);Blink1();break;//收到10 发送AA 55 0A 21 55 AA
                   
           case 11 :Serial.write(buf_1,2);Serial.write(11);Serial.write(33);
                   Serial.write(buf_2,2);Blink2();break;//收到11 发送AA 55 0B 21 55 AA
                   
           case 12 :Serial.write(buf_1,2);Serial.write(12);Serial.write(33);
                   Serial.write(buf_2,2);Blink3();break;//收到12 发送AA 55 0C 21 55 AA
                   
           case 13 :Serial.write(buf_1,2);Serial.write(10);Serial.write(33);
                   Serial.write(buf_2,2);Blink3();break;//收到13 发送AA 55 0D 21 55 AA   
        
          }
    }
}


void Blink1() 
{
  digitalWrite(ledPin, HIGH);//LED灯亮
  delay(1000);//等待1秒
  digitalWrite(ledPin, LOW);//LED灯灭
  delay(1000);
}

void Blink2() 
{
  digitalWrite(ledPin, HIGH);//LED灯亮
  delay(500);//等待500MS
  digitalWrite(ledPin, LOW);//LED灯灭
  delay(500);
  digitalWrite(ledPin, HIGH);//LED灯亮
  delay(500);//等待500MS
  digitalWrite(ledPin, LOW);//LED灯灭
  delay(500);
}
void Blink3() 
{
  digitalWrite(ledPin, HIGH);//LED灯亮
  delay(300);//等待300MS
  digitalWrite(ledPin, LOW);//LED灯灭
  delay(300);
  digitalWrite(ledPin, HIGH);//LED灯亮
  delay(300);//等待300MS
  digitalWrite(ledPin, LOW);//LED灯灭
  delay(300);
  digitalWrite(ledPin, HIGH);//LED灯亮
  delay(300);//等待300MS
  digitalWrite(ledPin, LOW);//LED灯灭
  delay(300);
}
