/*****************************************************************************************************************
 时间：2305252109
 事项：1、完成Arduino和CI-03T语音识别模块的串口通信代码；写了两种：一种是分散结构自己拼装；另一种是封装到一个函数里面；大家
       按照自己能力选取合适的代码即可。
      2、加油
 
 
 
 
基础知识梳理：
void setup（）： 这个函数是最开始的时候运行一次，（初始化函数）。
void loop （）：这个函数是执行函数，会不断循环工作，（死循环函数)。 

Serial.bengin() :这个函数对串口定义波特率
Serial.read() :    这个函数读串口并返回收到参数读取1byte的序列资料（读取串口的输入）
Serial.printnl():  在串口端打印输出数据（在串口打印输出）
*****************************************************************************************************************/
#include <Servo.h>

int ledPin = 13;  //定义LED引脚13
int vol = 0;      //定义一个vol

static int Send_buf[10] = {0} ; 

void setup() 
{
  Serial.begin(9600);
  // 参数speed是指串口通信波特率，波特率是指每秒传输的比特数，除以8就可以得到每秒传输的字节数，一般用9600、19200、57600、115200。
  pinMode( ledPin, OUTPUT);

}
 
void loop()//进入死循环，一直在这里轮回
{ 
  while (Serial.available()>0)//当串口接收到数据
    {
       char vol = Serial.read();//将接收到的数据赋值给vol
       switch(vol)                               //判断串口收到了哪个数据
         {
           case 1 :Blink1();break;              //如果串口收到1   LED亮灭一次
                   
           case 2 :Blink2();break;              //如果串口收到2   LED亮灭二次
                   
           case 3 :Blink3();break;              //如果串口收到3   LED亮灭三次
                   
           case 4 :Uart_SendCMD1(4, 4, 4);Blink1();break;//收到4 发送AA 55 04 04 04 55 AA
           
           case 5 :Uart_SendCMD1(5, 5, 5);Blink2();break;//收到5 发送AA 55 05 05 05 55 AA
                   
           case 6 :Uart_SendCMD1(6, 6, 6);Blink3();break;//收到6 
                   
           case 7 :Uart_SendCMD1(7, 7, 7);Blink1();break;//收到7 
                   
           case 8 :Uart_SendCMD1(8, 8, 8);Blink2();break;//收到8 
                   
           case 9 :Uart_SendCMD1(9, 9, 9);Blink3();break;//收到9 
                   
           case 10 :Uart_SendCMD1(10, 10, 10);Blink1();break;//收到A 
                   
           case 11 :Uart_SendCMD1(11, 11, 11);Blink2();break;//收到B 
                   
           case 12 :Uart_SendCMD1(12, 12, 12);Blink3();break;//收到C 
                   
           case 13 :Uart_SendCMD1(13, 13, 13);Blink1();break;//收到D   
                   
           case 14 :Uart_SendCMD1(14, 14, 14);Blink2();break;//收到E 
                   
           case 15 :Uart_SendCMD1(15, 15, 15);Blink3();break;//收到F 
                   
           case 16 :Uart_SendCMD2(16,16);Blink1();break;     //收到10         
          }
    }
}


/******************************************************************************
* 函数名称       ： Uart_SendCmd(int len)  
* 创建日期       ：  2023/05/25
* 创建人         ：  志城

* 函数功能       ：  调用USART2_SendByte();将数据逐个发送出来 

* 输入参数类型   ： int len = 3或2；在for语句处逐个将Send_buf[]数据发送出来

* 输出参数类型    ：
* 返回信息       ：
* 内在逻辑       ： 
*******************************************************************************/ 
void Uart_SendCmd(int len)
{  
    int i = 0 ;
    Serial.write(0xAA);       //起始
    Serial.write(0x55); 
  
    for(i=0; i<len; i++)         //数据
      {   
         Serial.write(Send_buf[i]);   //len 为3 ；依次将Send_buf[0]、Send_buf[1]、Send_buf[2]　发送出来 
      }
    
    Serial.write(0x55);       
    Serial.write(0xAA);      //结束
    
}


/********************************************************************************************
 - 功能描述： 串口向外发送温度数据
 - 隶属模块： 外部
 - 参数说明： datal:串口触发编号
            data2：温度整数
            data3:温度小数
 - 返回说明：
 - 注：       
********************************************************************************************/
void Uart_SendCMD1(int dat1, int dat2, int dat3)
{

    Send_buf[0] = (int)(dat1);         //datal
    Send_buf[1] = (int)(dat2);         //data2
    Send_buf[2] = (int)(dat3);         //data3
  
    Uart_SendCmd(3);                 //发送此帧数据   注意此处写3  
}


/********************************************************************************************
 - 功能描述： 串口向外发送湿度数据
 - 隶属模块： 外部
 - 参数说明： datal:串口触发编号
            data2：湿度数据
 - 返回说明：
 - 注：       
********************************************************************************************/
void Uart_SendCMD2(int dat1, int dat2)
{

    Send_buf[0] = (int)(dat1);         //datal
    Send_buf[1] = (int)(dat2);         //data2
  
    Uart_SendCmd(2);                   //发送此帧数据   
}



void Blink1() 
{
  digitalWrite(ledPin, HIGH);//LED灯亮
  delay(1000);//等待1秒
  digitalWrite(ledPin, LOW);//LED灯灭
  delay(1000);
}

void Blink2() 
{
  digitalWrite(ledPin, HIGH);//LED灯亮
  delay(500);//等待500MS
  digitalWrite(ledPin, LOW);//LED灯灭
  delay(500);
  digitalWrite(ledPin, HIGH);//LED灯亮
  delay(500);//等待500MS
  digitalWrite(ledPin, LOW);//LED灯灭
  delay(500);
}
void Blink3() 
{
  digitalWrite(ledPin, HIGH);//LED灯亮
  delay(300);//等待300MS
  digitalWrite(ledPin, LOW);//LED灯灭
  delay(300);
  digitalWrite(ledPin, HIGH);//LED灯亮
  delay(300);//等待300MS
  digitalWrite(ledPin, LOW);//LED灯灭
  delay(300);
  digitalWrite(ledPin, HIGH);//LED灯亮
  delay(300);//等待300MS
  digitalWrite(ledPin, LOW);//LED灯灭
  delay(300);
}
